; The following is the MYCNF.E used to build the .ex files for the OS2TOOLS
; version of EPM.  It is included in EMACROS.FLS as an example; please do
; *not* use it as a base MYCNF.E.  The MYCNF.E should only include changes
; from the STDCNF.E defaults; defining *everything* just makes it more
; difficult to debug problems.  The defaults are shown in parentheses.
; For possible values for each setting, see the documentation or STDCNF.E.
;
; (If you need to create an initial MYCNF.E and don't know what you're doing,
; go ahead and copy this file to MYCNF.E, then delete any lines for which you
; prefer to take the indicated default.)
;
; If you've compiled with SUPPORT_USERS_GUIDE = 1 (or have the distributed .ex
; files, which are compiled that way), and have EPMUSERS.INF in the current
; directory or a directory listed in your BOOKSHELF setting, you can get view
; the documentation for any configuration constant by placing the cursor on
; the constant name and selecting Help / View User's Guide / Current Word.

const
;   HOST_SUPPORT = 'EMUL'       -- ('STD') Use E3EMUL.  Following are for it:
;     USING = 'IBM'               -- ('CM') Send/Receive protocol    Needed for MVS
;     MVS = 1                     -- (0) Include MVS support
;     HOST_LT_REQUIRED = 1        -- (0) H: refers to PC; HA: refers to host.
   HOST_SUPPORT = ''       -- ('STD') Use E3EMUL.  Following are for it:
     USING = ''               -- ('CM') Send/Receive protocol    Needed for MVS
     MVS = 0                     -- (0) Include MVS support
     HOST_LT_REQUIRED = 0        -- (0) H: refers to PC; HA: refers to host.
compile if EVERSION < '6.00c'
   LINK_HOST_SUPPORT = 1       -- (0) Must link in host support; no room in base.
   P_SYNTAX_ASSIST = 0      -- (1) Pascal
compile endif
   REXX_SYNTAX_ASSIST = 1      -- (0) Include Rexx syntax assist
compile if EVERSION < '6.00c'
   WANT_STACK_CMDS = 'SWITCH'  -- (0) Include this; nice to have
compile else
   WANT_STACK_CMDS = 1         -- (0) Leave on all the time; can't toggle w/ new menus
compile endif
   WANT_ALL = 1                -- (0) Include this; nice to have
   WANT_SEARCH_PATH = 1        -- (0) Include this; nice to have
   WANT_LAN_SUPPORT = 1        -- (0) Include this; nice to have

   SETSTAY = '?'               -- (0) Enable the STAY comamnd
   WANT_STREAM_MODE = 'SWITCH' -- (0) Enable switching stream mode on and off
   WANT_CUA_MARKING = 'SWITCH' -- (0) Enable switching between CUA and advanced marking
   ENHANCED_ENTER_KEYS = 1     -- (0) Let users configure each enter key separately
   ENHANCED_PRINT_SUPPORT = 1  -- (0) Support list of printers
   WANT_DBCS_SUPPORT = 1       -- (0) Include support for DBCS
compile if EVERSION < '6.00c'
   EXTRA_EX = 1                -- (0) To make room in EPM.EX for everything we need
compile endif
   WANT_BRACKET_MATCHING = 1   -- (0) Include bracket matching code.
   WANT_KEYWORD_HELP = 1       -- (0) Include keyword lookup code.
   WANT_EPM_SHELL = 1          -- (0) Include the shell window support
   WANT_LONGNAMES = 'SWITCH'   -- (0) Enable switching on longname support
   WANT_PROFILE = 'SWITCH'     -- (0) Enable switching on Rexx profile support
   TOGGLE_TAB = 1              -- (0) Enable toggling Tab key to insert a tab character.
   C_TABS       = '3'            -- (3) Users who don't recompile can't control this, so don't set.
   C_MARGINS    = 0            -- (1 254 1)  "
   E_TABS       = '3'            -- (3)        "
   E_MARGINS    = 0            -- (1 254 1)  "
   REXX_TABS    = 0            -- (3)        "
   REXX_MARGINS = 0            -- (1 254 1)  "
   P_TABS       = '3'            -- (3)        "
   P_MARGINS    = 0            -- (1 254 1)  "
   O_TABS       = '3'
   O_MARGINS    = 0
   BLOCK_ACTIONBAR_ACCELERATORS='SWITCH'  -- (1) Switch CUA menu support on/off
compile if EVERSION >= '6.00c'
;; STD_MENU_NAME = 'ovshmenu.e' -- (undef) Use WOVSH menu style
   STD_MENU_NAME = 'fevshmnu.e' -- (undef) Use WFEVSH menu style
   my_STACK_CMDS = 1           -- (0) Initialize to stack cmds visible
   WANT_TAGS = 1               -- (0) Include support for 'tags' file
compile elseif EVERSION >= '5.60'
   WANT_TAGS = 'DYNALINK'      -- (0) Include support for 'tags' file
compile endif
compile if EVERSION < '5.60'
   WANT_TRUNCATED_WARNING = 1  -- (0) Give a pop-up for "Lines truncated" warning
compile endif
   DYNAMIC_CURSOR_STYLE = 1    -- (0) Allow selecting cursor style at run time
   EPM_POINTER = 'SWITCH'      -- (2) Allow selecting mouse pointer style at run time
   SUPPORT_USERS_GUIDE = 1     -- (0) Include a reference to the EPM User's Guide on the Help menu
   SUPPORT_TECHREF = 1         -- (0) Include a reference to the EPM Macro Programmer's Tech. Ref. on the Help menu

define
   DRAGCOLOR = ''              -- (YELLOW + MAGENTAB) This will use .markcolor for the .dragcolor.

compile if defined(BLACK)
define
   HIGHLIGHT_COLOR = Yellow + Magentab  -- ('') Default is no highlight after Locate
compile endif
   C_KEYWORD_HIGHLIGHTING = 1
   WANT_BRACE_BELOW_STATEMENT=1
   WANT_BRACKET_MATCHING=1
   WANT_BOOKMARKS=1
   INCLUDE_WORKFRAME_SUPPORT=1
   OBERON_KEYWORD_HIGHLIGHTING = 1
   OBERON_SYNTAX_ASSIST = 1
   TERMINATE_COMMENTS = 1
